﻿<UserControl x:Class="xAPI_VS_Extension.xAPI_ExtensionControl"
             xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
             xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
             xmlns:vsshell="clr-namespace:Microsoft.VisualStudio.Shell;assembly=Microsoft.VisualStudio.Shell.15.0"
             xmlns:vm="clr-namespace:xAPI_VS_Extension.ViewModel"
             xmlns:parser="clr-namespace:xAPI_Definitions_Parser;assembly=xAPI_Definitions_Parser"
             xmlns:conv="clr-namespace:xAPI_VS_Extension.Converters"
             xmlns:i="http://schemas.microsoft.com/xaml/behaviors"
             Background="{DynamicResource {x:Static vsshell:VsBrushes.WindowKey}}"
             Foreground="{DynamicResource {x:Static vsshell:VsBrushes.WindowTextKey}}"
             mc:Ignorable="d"
             d:DesignHeight="300" d:DesignWidth="300"
             Name="MyToolWindow">
    <UserControl.Resources>
        <Style TargetType="{x:Type TreeViewItem}">
            <Setter Property="IsExpanded" Value="True"/>
        </Style>
        <conv:BoolInverseConverter x:Key="BoolInverseConverter"/>
    </UserControl.Resources>
    <ScrollViewer HorizontalScrollBarVisibility="Auto" VerticalScrollBarVisibility="Auto"
                  IsEnabled="{Binding Path=IsWorking, Converter={StaticResource BoolInverseConverter}}"
                  Name="ScrollViewer">
        <Grid>
            <Grid.RowDefinitions>
                <RowDefinition Height="Auto"/>
                <RowDefinition Height="2*"/>
                <RowDefinition Height="*"/>
            </Grid.RowDefinitions>
            <Label Grid.Row="0" Content="Sources" FontWeight="Bold"/>
            <!--<ScrollViewer Grid.Row="1" HorizontalScrollBarVisibility="Auto" VerticalScrollBarVisibility="Disabled"
                          IsEnabled="{Binding Path=IsWorking, Converter={StaticResource BoolInverseConverter}}"
                          Name="ScrollViewer" Margin="5,0,5,0">-->
                <ItemsControl Grid.Row="1" ItemsSource="{Binding Trees}" Margin="5,0,5,0">
                    <ItemsControl.ItemsPanel>
                        <ItemsPanelTemplate>
                            <StackPanel Orientation="Horizontal"/>
                        </ItemsPanelTemplate>
                    </ItemsControl.ItemsPanel>
                    <ItemsControl.ItemTemplate>
                        <DataTemplate>
                            <Grid>
                                <Grid.RowDefinitions>
                                    <RowDefinition Height="Auto"/>
                                    <RowDefinition Height="*"/>
                                </Grid.RowDefinitions>
                                <Label Grid.Row="0" Content="{Binding Name}" FontWeight="Bold"/>
                                <TreeView Grid.Row="1" ItemsSource="{Binding Sources}" PreviewMouseWheel="TreeView_PreviewMouseWheel" MinWidth="300" MaxHeight="410"
                                            ScrollViewer.HorizontalScrollBarVisibility="Disabled" ScrollViewer.VerticalScrollBarVisibility="Auto">
                                    <TreeView.ItemContainerStyle>
                                        <Style TargetType="TreeViewItem">
                                            <Setter Property="IsExpanded" Value="{Binding IsExpanded}"/>
                                        </Style>
                                    </TreeView.ItemContainerStyle>
                                    <TreeView.ItemTemplate>
                                        <HierarchicalDataTemplate DataType="{x:Type vm:CheckableViewModel}" ItemsSource="{Binding Children}">
                                            <StackPanel Orientation="Horizontal" Margin="0,-4,0,0">
                                                <CheckBox IsChecked="{Binding IsChecked}" Margin="0,5,0,0"/>
                                                <Label Content="{Binding Name}"/>
                                            </StackPanel>
                                        </HierarchicalDataTemplate>
                                    </TreeView.ItemTemplate>
                                    <TreeView.ContextMenu>
                                        <ContextMenu>
                                            <MenuItem Header="Remove source" Click="TreeViewMenuItemRemove_Click"/>
                                        </ContextMenu>
                                    </TreeView.ContextMenu>
                                </TreeView>
                            </Grid>
                        </DataTemplate>
                    </ItemsControl.ItemTemplate>
                </ItemsControl>
            <!--</ScrollViewer>-->
            <Grid Grid.Row="2">
                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="Auto"/>
                    <ColumnDefinition Width="100"/>
                    <ColumnDefinition Width="Auto"/>
                </Grid.ColumnDefinitions>
                <Grid.RowDefinitions>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="*"/>
                </Grid.RowDefinitions>
                <Label Grid.Column="0" Grid.Row="0" Content="Source Configuration" FontWeight="Bold"
                       IsEnabled="{Binding Path=IsWorking, Converter={StaticResource BoolInverseConverter}}"/>
                <Grid Grid.Column="0" Grid.Row="1" IsEnabled="{Binding Path=IsWorking,
                    Converter={StaticResource BoolInverseConverter}}">
                    <Grid.ColumnDefinitions>
                        <ColumnDefinition Width="Auto"/>
                        <ColumnDefinition Width="Auto" MinWidth="350"/>
                        <ColumnDefinition Width="Auto"/>
                        <ColumnDefinition Width="Auto"/>
                        <ColumnDefinition Width="*"/>
                    </Grid.ColumnDefinitions>
                    <Grid.RowDefinitions>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="*"/>
                    </Grid.RowDefinitions>
                    <Grid.Resources>
                        <Style x:Key="LabelLocalEnabled" TargetType="{x:Type Label}">
                            <Setter Property="IsEnabled" Value="False"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding SourceType}" Value="{x:Static parser:SourceType.Local}">
                                    <Setter Property="IsEnabled" Value="True"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                        <Style x:Key="LabelGitLabEnabled" TargetType="{x:Type Label}">
                            <Setter Property="IsEnabled" Value="False"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding SourceType}" Value="{x:Static parser:SourceType.GitLab}">
                                    <Setter Property="IsEnabled" Value="True"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                        <Style x:Key="TextBoxLocalEnabled" TargetType="{x:Type TextBox}">
                            <Setter Property="IsEnabled" Value="False"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding SourceType}" Value="{x:Static parser:SourceType.Local}">
                                    <Setter Property="IsEnabled" Value="True"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                        <Style x:Key="TextBoxGitLabEnabled" TargetType="{x:Type TextBox}">
                            <Setter Property="IsEnabled" Value="False"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding SourceType}" Value="{x:Static parser:SourceType.GitLab}">
                                    <Setter Property="IsEnabled" Value="True"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                        <Style x:Key="ButtonLocalEnabled" TargetType="{x:Type Button}">
                            <Setter Property="IsEnabled" Value="False"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding SourceType}" Value="{x:Static parser:SourceType.Local}">
                                    <Setter Property="IsEnabled" Value="True"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                    </Grid.Resources>
                    <Label Grid.Column="0" Grid.Row="0" Content="Source Type"/>
                    <ComboBox Grid.Column="1" Grid.ColumnSpan="2" Grid.Row="0" ItemsSource="{Binding SourceTypes}" DisplayMemberPath="Value" SelectedValuePath="Key" SelectedValue="{Binding SourceType}"
                              Width="440"/>

                    <Label Grid.Column="0" Grid.Row="1" Content="Source Path"/>
                    <TextBox Grid.Column="1" Grid.Row="1" Text="{Binding Path}" VerticalContentAlignment="Center"
                             Width="415"/>
                    <Button Grid.Column="2" Grid.Row="1" Height="25" Width="25" Style="{StaticResource ButtonLocalEnabled}" Click="BrowsePathBtn_Click">
                        <Image Source="Resources/OpenFolder_16x.png" Height="16" Width="16"/>
                    </Button>

                    <Label Grid.Column="0" Grid.Row="2" Content="Project ID" Style="{StaticResource LabelGitLabEnabled}"/>
                    <TextBox Grid.Column="1" Grid.ColumnSpan="2" Grid.Row="2" Text="{Binding ProjectId}" VerticalContentAlignment="Center" Style="{StaticResource TextBoxGitLabEnabled}"
                             Width="440"/>

                    <Label Grid.Column="0" Grid.Row="3" Content="Private Key" Style="{StaticResource LabelGitLabEnabled}"/>
                    <TextBox Grid.Column="1" Grid.ColumnSpan="2" Grid.Row="3" Text="{Binding PrivateKey}" VerticalContentAlignment="Center" Style="{StaticResource TextBoxGitLabEnabled}"
                             Width="440"/>

                    <Label Grid.Column="0" Grid.Row="4" Content="Branch ('master' if empty)" Style="{StaticResource LabelGitLabEnabled}"/>
                    <TextBox Grid.Column="1" Grid.ColumnSpan="2" Grid.Row="4" Text="{Binding Branch}" VerticalContentAlignment="Center" Style="{StaticResource TextBoxGitLabEnabled}"
                             Width="440"/>

                    <Button Grid.Column="3" Grid.Row="1" Width="120" HorizontalAlignment="Left" Content="Add Source" Command="{Binding AddSrcBtnCmd}" Margin="10,0,0,0"
                            ToolTip="Adds a source based on the source configuration."/>
                </Grid>
                <Label Grid.Column="2" Grid.Row="0" Content="Output Configuration" FontWeight="Bold"
                       IsEnabled="{Binding Path=IsWorking, Converter={StaticResource BoolInverseConverter}}"/>
                <Grid Grid.Column="2" Grid.Row="1" IsEnabled="{Binding Path=IsWorking,
                    Converter={StaticResource BoolInverseConverter}}">
                    <Grid.ColumnDefinitions>
                        <ColumnDefinition Width="Auto"/>
                        <ColumnDefinition Width="Auto" MinWidth="350"/>
                        <ColumnDefinition Width="Auto"/>
                        <ColumnDefinition Width="Auto"/>
                        <ColumnDefinition Width="*"/>
                    </Grid.ColumnDefinitions>
                    <Grid.RowDefinitions>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="Auto"/>
                        <RowDefinition Height="*"/>
                    </Grid.RowDefinitions>
                    <Label Grid.Column="0" Grid.Row="0" Content="Language"/>
                    <ComboBox Grid.Column="1" Grid.ColumnSpan="2" Grid.Row="0" ItemsSource="{Binding Languages}" DisplayMemberPath="Value" SelectedValuePath="Key" SelectedValue="{Binding Language}"
                              Width="440"/>

                    <Label Grid.Column="0" Grid.Row="1" Content="Output Type"/>
                    <ComboBox Grid.Column="1" Grid.ColumnSpan="2" Grid.Row="1" ItemsSource="{Binding OutputTypes}" SelectedValue="{Binding OutputType}"
                              Width="440"/>

                    <Label Grid.Column="0" Grid.Row="2" Content="Project"/>
                    <TextBox Grid.Column="1" Grid.Row="2" Text="{Binding Project}" VerticalContentAlignment="Center"
                             Width="415"/>
                    <Button Grid.Column="2" Grid.Row="2" Height="25" Width="25" Click="BrowseProjectBtn_Click">
                        <Image Source="Resources/OpenFolder_16x.png" Height="16" Width="16"/>
                    </Button>

                    <Label Grid.Column="0" Grid.Row="3" Content="Destination"/>
                    <TextBox Grid.Column="1" Grid.ColumnSpan="2" Grid.Row="3" Text="{Binding Destination}" VerticalContentAlignment="Center" IsEnabled="False"
                             Width="440"/>

                    <Button Grid.Column="3" Grid.Row="2" Width="120" HorizontalAlignment="Left" Content="Generate" Command="{Binding AddToProjBtnCmd}" Margin="10,0,0,0"
                            ToolTip="Generates code and adds it to the specified project."/>
                </Grid>
                <Label Grid.Column="0" Grid.Row="2" Content="{Binding Status, UpdateSourceTrigger=PropertyChanged, NotifyOnSourceUpdated=True}"/>
            </Grid>
        </Grid>
    </ScrollViewer>
</UserControl>